function createVirtualThermostat (name, title, sensor_name, relay_name, hist) { 
	defineVirtualDevice(name, {
		title: title,
		cells: {
			"target_temp": {
				type: "range",
				max: 24,
				value: 20.0,
			},
          	"temp": {
				type: "value",
				value: 0,
			},
			"heating": {
				type: "switch",
				value: false,
			},
			"sensor_name": {
				type: "text",
				value: sensor_name,
			},
			"relay_name": {
				type: "text",
				value: relay_name,
			},
          	"relay": {
				type: "switch",
				value: false,
                readonly: true,
			},
			"hist": {
				type: "value",
				value: hist,
			}
		}

	});
    function RunThermostat(newValue, devName, cellName){
      log.info(devName + "/" + cellName + "=" + newValue);
      
      if ((dev[sensor_name] > (dev[name]["target_temp"] + dev[name]["hist"]) || !dev[name]["heating"])){		  
				  dev[dev[name]["relay_name"]] = false;
         		  dev[name]["relay"] = false;
        		  log.info(dev[name]["relay_name"] + " set off");
			  }				  
			  else {				
				 dev[dev[name]["relay_name"]] = true;
                 dev[name]["relay"] = true;
                 log.info(dev[name]["relay_name"] + " set on");
			  }
       dev[name]["temp"] = dev[sensor_name]; 
      
	 }; 
	defineRule(name + "_Sensor_rule",{
		whenChanged: sensor_name,
		then: RunThermostat              
	});
    defineRule(name + "_Switch_rule",{
		whenChanged: name + "/heating" ,
		then: RunThermostat              
	});
    defineRule(name + "_Range_rule",{
		whenChanged: name + "/target_temp",
		then: RunThermostat              
	});
    
	
};

//createVirtualThermostat("therm_wb1", "Отопление 1 этаж", "wb-w1/28-031664d861ff","wb-mr3_58/K1",1);
createVirtualThermostat("therm_wb1", "Отопление 1 этаж", "WB-ZB-env01/temperature","wb-mr3_58/K1",1);
createVirtualThermostat("therm_wb2", "Отопление Детская ", "WB-ZB-env02/temperature","wb-mr3_58/K2",1);
createVirtualThermostat("therm_wb3", "Отопление Спальня", "WB-ZB-env03/temperature","wb-mr3_58/K3",1);
